import java.io.*;

// Java 17: Sealed Classes
public sealed abstract class MaartenJava17 {
    public static void main(String[] args) throws IOException {
        try (BufferedReader reader = new BufferedReader(new InputStreamReader(System.in))) {
            new Solution().run(reader);
        }
    }
}

final class Solution extends MaartenJava17 {
    public void run(BufferedReader reader) throws IOException {
        int n = Integer.parseInt(reader.readLine());
        double totalVolume = 0;

        String[] xs = reader.readLine().split(" ");
        for (String x : xs) {
            double d = Double.parseDouble(x);
            totalVolume += d * d * d;
        }

        // Java 14: Switch Expression
        System.out.println(switch (42) {
            default -> Math.cbrt(totalVolume);
        });
    }
}
